/*
 * killnova.c                20-NOV-1993            Yasuo TAKEUCHI (T.I.T.)
 *
 *  Kill buffer manager and nova daemon
 *
 *  usage:  killnova [socket_name]
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>
#include "nova.h"

#define COMMAND       "exit_bm"
#define DEFAULT_NAME  "/tmp/nova"

main(argc, argv)
int argc;
char *argv[];
{
    int sd;
    struct sockaddr_un server;
    char name[NV_MAXNAME + 1];

    /* read option */
    strcpy(name, (argc > 1) ? argv[1] : DEFAULT_NAME);

    /* create socket */
    if((sd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0) {
	perror("opening stream socket");
	exit(1);
    }

    /* connect socket */
    server.sun_family = AF_UNIX;
    strcpy(server.sun_path, name);
    if (connect(sd, &server, sizeof(struct sockaddr_un)) < 0) {
	perror("connecting stream socket");
	close(sd);
	exit(2);
    }

    /* send command */
    if (write(sd, COMMAND, strlen(COMMAND)) < 0) {
	perror("writing on stream socket");
	close(sd);
	exit(3);
    }

    /* exit */
    close(sd);
    exit(0);
}
