/* Buffer manager header file
 *
 *    bm.h       09-SEP-1992		Masaharu NOMACHI
 *
 *  Buffer manager consists with three parts.
 *    1) communication part
 *    2) buffer management part
 *    3) buffer request/status part
 *  Each part has its own data base for each process/buffer.
 *  Those data bases are defined in those header files.
 *  BMT_xxx pointer head points those data-bases.
 *  Each part can refer the other part by passing the pointer to 
 *  BMT structure. 
 *
 */

struct BMT_process {
    char *p_com;	/* Pointer to communication data base		 */
    char *p_exec;	/* Pointer to buffer management data base	 */
    char *p_req;	/* Pointer to buffer request table		 */
    int id;
};

struct BMT_buffer {
    char *b_com;	/* Pointer to communication data base (not used) */
    char *b_exec;	/* Pointer to buffer management data base	 */
    char *b_status;	/* Pointer to buffer status table		 */
    int id;
};

#define BASE_ID 1000

#define NULL_ptable ((struct BMT_process *)0)
#define NULL_btable ((struct BMT_buffer  *)0)

/* buffer manager error code */
#define BME_INVADR -100         /* Invalid address     */
#define BME_INVSIZ -200         /* Invalid buffer size */
