/*
 * net_analyzer_fast.c
 *                   Simple analyzer for net nova development
 *
 *              version 1.03  09-OCT-1992 M. Nomachi (KEK)
 *
 */
#include "novanet.h"
#include "nova.h"

#define DEFAULT_HOST     "psuxnc"
#define DEFAULT_NAME     "/tmp/nova"
#define DEFAULT_PRI      50

int buffer[128*1024];

main(argc, argv) int argc; char *argv[]; {
  struct NOVAD *nd, *nova_copen();
  char host[NOVA_HOSTNAME_MAX + 1];
  char name[NV_MAXNAME + 1];
  int length, priority;
  int status, loop, i, sleep_time;
  int get_count, skip_count;
  
  /* Read options */
  priority   = (argc > 1) ? atoi(argv[1]) : DEFAULT_PRI;
  strcpy(host, (argc > 2) ? argv[2] : DEFAULT_HOST);
  strcpy(name, (argc > 3) ? argv[3] : DEFAULT_NAME);
  
  /* open NOVA */
  if ((int)(nd = net_nova_open(host, 0, name, priority,1)) == -1) {
    printf("net analyzer: cannot open %s:%s\n", host,name);
    exit(1);
  }
  
  get_count = 0;
  skip_count = 0;
  loop = 0;
  while(1) {
    alarm(10);
    status = net_nova_read(nd, buffer, sizeof(buffer));
    if (status>0) {   /* nomal */
      skip_count += (buffer[0]-loop-1);
      loop = buffer[0];
      get_count++;
    }
    else if (status == 0) {  /* Interrupted */
      printf("Time out! get %d / %d",get_count, get_count+skip_count);
      if (get_count+skip_count) 
	printf(" %d%%\n",100*get_count/(get_count+skip_count));
      else 
	printf("\n");
      get_count = 0;
      skip_count = 0;
      loop = 0;
    }
    else {  /* error */
      printf("net analyzer: error! %d\n",status);
      break;
    }
  }
  
  printf("analyzer: nomal end.\n");
  net_nova_close(nd);
}

